--run the alter command in sqlplus.
--alter session set NLS_DATE_FORMAT='yyyy/mm/dd:hh:mi:ssam';

spool mig-2.log;
select sysdate from dual;

INSERT INTO BLOCKS
(
  BLOCK_ID,                                 
   BLOCK_NAME,
    DATASET_ID,
     OPEN_FOR_WRITING, 
      BLOCK_SIZE,
       FILE_COUNT,
        CREATION_DATE,
	 CREATE_BY,
	  LAST_MODIFICATION_DATE,
	  LAST_MODIFIED_BY,	
	   ORIGIN_SITE_NAME
	  )
SELECT B.ID, B.NAME, B.DATASET, B.OPENFORWRITING, 
              B.BLOCKSIZE, B.NUMBEROFFILES, B.CREATIONDATE,
	             PDCB.DISTINGUISHEDNAME, B.LASTMODIFICATIONDATE,
		     PDCB2.DISTINGUISHEDNAME, 'UNKNOWN'
		     FROM CMS_DBS_PROD_GLOBAL.BLOCK B
		     LEFT OUTER JOIN CMS_DBS_PROD_GLOBAL.PERSON PDCB
		         ON B.CREATEDBY=PDCB.ID
		     LEFT OUTER JOIN CMS_DBS_PROD_GLOBAL.PERSON PDCB2
                         ON B.LASTMODIFIEDBY=PDCB2.ID;	

commit;
select 'Done insert BLOCKS' from dual;
select sysdate from dual;

INSERT into BLOCK_PARENTS(THIS_BLOCK_ID, PARENT_BLOCK_ID)
SELECT BP.THISBLOCK, BP.ITSPARENT FROM CMS_DBS_PROD_GLOBAL.BLOCKPARENT BP; 
commit;
select 'Done insert BLOCKS_PARENTS' from dual;
select sysdate from dual;

INSERT INTO FILE_DATA_TYPES ( FILE_TYPE_ID,  FILE_TYPE ) SELECT ID, TYPE FROM CMS_DBS_PROD_GLOBAL.FILETYPE;
commit;
select 'Done insert FILE_DATA_TYPES' from dual;
select sysdate from dual;


ALTER TABLE FILES DROP constraint CC_FL_IS_FILE_VALID;

ALTER TABLE FILES DROP constraint TUC_FL_LOGICAL_FILE_NAME;

ALTER TABLE FILES DROP constraint  DS_FL;

ALTER TABLE FILES DROP constraint  BK_FL;

ALTER TABLE FILES DROP constraint  FT_FL;

ALTER TABLE FILES DROP constraint BH_FL;

drop index IDX_FL_1;

drop index IDX_FL_2;

drop index IDX_FL_3;

drop index IDX_FL_4;

drop index IDX_FL_5;

drop index IDX_FL_6;

drop index IDX_FL_7;

INSERT  /*+ append */ INTO FILES
(
  FILE_ID,
   LOGICAL_FILE_NAME,
    IS_FILE_VALID,
     DATASET_ID,
      BLOCK_ID,
       FILE_TYPE_ID,
        CHECK_SUM,
	 EVENT_COUNT,
	  FILE_SIZE,
	   ADLER32,
	    MD5,
	     AUTO_CROSS_SECTION,
	      CREATION_DATE,
	       CREATE_BY,
	        LAST_MODIFICATION_DATE,
		 LAST_MODIFIED_BY
		 )
SELECT F.ID, F.LOGICALFILENAME, F.VALIDATIONSTATUS, F.DATASET, F.BLOCK,
       F.FILETYPE, F.CHECKSUM, F.NUMBEROFEVENTS, F.FILESIZE, F.ADLER32,
       F.MD5, F.AUTOCROSSSECTION, F.CREATIONDATE,
       PDCB.DISTINGUISHEDNAME, F.LASTMODIFICATIONDATE, PDLM.DISTINGUISHEDNAME
       FROM CMS_DBS_PROD_GLOBAL.FILES F
       LEFT OUTER JOIN CMS_DBS_PROD_GLOBAL.PERSON PDCB
           ON F.CREATEDBY=PDCB.ID
	   LEFT OUTER JOIN CMS_DBS_PROD_GLOBAL.PERSON PDLM
	       ON F.LASTMODIFIEDBY=PDLM.ID;
commit;
select 'Done insert FILES' from dual;
select sysdate from dual;

CREATE INDEX IDX_FL_1 ON FILES
(DATASET_ID);


CREATE INDEX IDX_FL_2 ON FILES
(BLOCK_ID);


CREATE INDEX IDX_FL_3 ON FILES
(FILE_TYPE_ID)
;


CREATE INDEX IDX_FL_4 ON FILES
(BRANCH_HASH_ID);


CREATE INDEX IDX_FL_5 ON FILES
(FILE_SIZE);


CREATE INDEX IDX_FL_6 ON FILES
(CREATION_DATE);


CREATE INDEX IDX_FL_7 ON FILES
(CREATE_BY);


ALTER TABLE FILES ADD (
  CONSTRAINT CC_FL_IS_FILE_VALID
 CHECK (IS_FILE_VALID in (1,0)),
  CONSTRAINT TUC_FL_LOGICAL_FILE_NAME
 UNIQUE (LOGICAL_FILE_NAME)
    USING INDEX )
;

ALTER TABLE FILES ADD (
  CONSTRAINT DS_FL 
 FOREIGN KEY (DATASET_ID) 
 REFERENCES DATASETS (DATASET_ID)
    ON DELETE CASCADE,
  CONSTRAINT BK_FL 
 FOREIGN KEY (BLOCK_ID) 
 REFERENCES BLOCKS (BLOCK_ID)
    ON DELETE CASCADE,
  CONSTRAINT FT_FL 
 FOREIGN KEY (FILE_TYPE_ID) 
 REFERENCES FILE_DATA_TYPES (FILE_TYPE_ID),
  CONSTRAINT BH_FL 
 FOREIGN KEY (BRANCH_HASH_ID) 
 REFERENCES BRANCH_HASHES (BRANCH_HASH_ID)
    ON DELETE SET NULL);

select 'Done FILES Constraints' from dual;
select sysdate from dual;


INSERT INTO FILE_PARENTS(THIS_FILE_ID, PARENT_FILE_ID)
SELECT FP.THISFILE, FP.ITSPARENT FROM CMS_DBS_PROD_GLOBAL.FILEPARENTAGE FP;
commit;
select 'Done insert FILE_PARENTS' from dual;
select sysdate from dual;
spool off
